import { Store, StoreSubscribeCallback, StoreOptions } from '../store/vanilla';
import { ElementOrSelector } from '../utils';
export interface AttributeOptions<T> extends StoreOptions<T> {
    sync?: boolean;
}
export declare class Attribute<T extends string | number | boolean> extends Store<T> {
    #private;
    constructor(elementOrSelector: ElementOrSelector, name: string, defaultValue: T, options?: AttributeOptions<T>);
    subscribe(callback: StoreSubscribeCallback<T>): () => void;
    unsubscribe(callback: StoreSubscribeCallback<T>): void;
    observe(): void;
    unobserve(): void;
    close(): void;
}
